package index.MyMtree;

public final class Neighbors {
	private final int k;
	double[] dist;
	Sphere[] nearest;
	double maxDist;
	final int[] query;
	int pointerMBRmaxDist = 0;
	int size = 0;
	final index.structures.IndexMyMtree tree = index.structures.IndexMyMtree.tree;
	
	public Neighbors(final int[] _query){
		k = 1;
		query = _query;
		init();
	}
	public Neighbors(int _k, final int[] _query){
		k = _k;
		query = _query;
		init();
	}
	
	private void init(){
		dist 	= new double[k];
		nearest = new Sphere[k];
		for(int i=0;i<k;i++){
			dist[i] = Double.MAX_VALUE;
		}
		maxDist = Double.MAX_VALUE;
	}
	
	public void update(final Sphere sphere){
		final int[] toCheck = tree.getDataset(sphere.TID);
		double currDist = tree.getMetric().calculateDistance(toCheck, query);
			
		//insert only if nearer
		if (currDist<maxDist){
			dist[pointerMBRmaxDist] = currDist;
			nearest[pointerMBRmaxDist] = sphere;
			//find new pointer value
			double newMaxDist = Double.MIN_VALUE;
			int newPointer = -1;
			for (int i=0;i<k;i++){
				if (dist[i]>newMaxDist){
					newPointer = i;
					newMaxDist = dist[i];
				}
			}
			maxDist = newMaxDist;
			pointerMBRmaxDist = newPointer;
		}//else ignore this one
	}
	public int[][] toArray(){
		int neighbors[][] = new int[this.k][];
		//XXX do not forget to sort
		for(int point=0;point<k;point++){
			//re-consider minBorder == maxBorder
			neighbors[point] = this.nearest[point].center;
		}
		return neighbors;
	}
}
