package index.MyMtree;

import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;

import index.base.AIndexStructure;
import index.structures.IndexMyMtree;;

public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		int[][] data = getData();
		
		AIndexStructure tree = new IndexMyMtree(data.length, data[0].length, 0, 255, null);
		
		for(int point=0;point<data.length;point++){
			tree.insert_Internal(data[point]);
		}
		Test t = new Test();
		TreeValidator v = t.new TreeValidator((IndexMyMtree)tree);
		v.validate();
		//v.pointCheck();
		v.queryExact(data);
	}
	
	public static void validate(){
		IndexMyMtree tree = IndexMyMtree.tree;
		Test t = new Test();
		TreeValidator v = t.new TreeValidator((IndexMyMtree)tree);
		v.validate();
	}

	private static int[][] getData() {
		final int UPPER_BOUND = 128;
		final int[][] data = new int[UPPER_BOUND*UPPER_BOUND][2];
		
		int counter = 0;
		for(int x=0;x<UPPER_BOUND;x++){
			for(int y=0;y<UPPER_BOUND;y++){
				data[counter][0] = x;
				data[counter][1] = y;
				counter++;
			}
		}

		return data;
	}
	
	/**
	 * General tree validator 
	 * @author amartin
	 *
	 */
	private final class TreeValidator{
		final IndexMyMtree tree;
		Comparator<Sphere> comp = new Comparator<Sphere>() {
			@Override
			public int compare(Sphere o1, Sphere o2) {
				if(o1.center[0]==o2.center[0]){//wenn x gleich
					return (o1.center[1]<=o2.center[1]) ? -1 : 1;
				}else{
					return (o1.center[0]<=o2.center[0]) ? -1 : 1;
				}	
			}
		};
		
		TreeValidator(IndexMyMtree t){
			this.tree = t;
		}
		
		public void validate(){
			validate(tree.getRoot());
		}
		
		private void validate(Sphere parent){
			final int SIZE = parent.size();
			
			for(int i=0;i<SIZE;i++){
				Sphere child = parent.children[i];
				
				
				if(!parent.contains(child)){
					System.err.println("Not contained "+parent+" -> "+child);
				}
				
				if(!child.isPoint())
					validate(child);
			}
		}
		
		public void pointCheck(){
			Sphere root = tree.getRoot();
			LinkedList<Sphere> points = new LinkedList<Sphere>();
			traverseTree(root, points);
			Collections.sort(points, comp);
			Iterator<Sphere> iter =  points.iterator();
			
			Sphere point;
			while(iter.hasNext()){
				point = iter.next();
				System.out.println(point);
				String pathUp = "";
				Sphere parent = point.parent;
				while(parent!=null){
					pathUp += " -> " + parent;
					parent = parent.parent;
				}
				System.out.println(pathUp);
			}
		}
		
		void traverseTree(Sphere node, LinkedList<Sphere> points){
			Sphere child;
			for(int i=0;i<node.size();i++){
				child = node.children[i];
				if(!child.isPoint())
					traverseTree(child, points);
				else
					points.add(child);
			}
		}
		
		public void queryExact(final int[][] dataset){
			for(int i=0;i<dataset.length;i++){
				final int[] point = dataset[i];
				int[] response = tree.search(point);
				if(response==null){
					System.err.println(i + " Not found");
				}
			}
		} 
	}

}
